-----------------------------------------------------------------------------------------
--
-- Utils.lua
--
-----------------------------------------------------------------------------------------
--
-- (c) 2012 lightanddepth.com                                            
--                                                                          
-- This is commercial software,  only users who have purchased a valid 
-- license and accept to the terms of the License Agreement can modify 
-- and use this program.                                                    
--                                                                          
-----------------------------------------------------------------------------------------


local Utils = {}


Utils.curry1 = function(f, p1)
    return function(p2) return f(p1, p2) end
end


Utils.filter = function(f, list)
    local ret = {}
    for i=1,#list do
        local a = list[i]
        if f(a) then
            ret[#ret+1] = a
        end
    end
    return ret
end


Utils.jsonFile = function( filename )

local json = require "json"

    local base = system.ResourceDirectory
    local path = system.pathForFile( filename, base )
    local contents
    local file = io.open( path, "r" )
    if file then
        contents = file:read( "*a" )
        io.close( file )
        return json.decode( contents )
    else
        error("json error " .. filename)
    end
end


return Utils