local mydata = require"mydata"
--local btnMain = require( "btnMain" )
--local fEvents = require( "fEvents" )
local Piece = { GRAY=-2, STICKY=-1, FIXED=0, G1=1, G2=2, G3=3, G4=4, G5=5, G6=6, G7=7, Blank=25}  --key = 8, gem = 9, glass = 10, fish = 12, web = 14

mydata.Base = TexturePack.new( "gfx/Base.txt","gfx/Base.png",  true)

mydata.colorTable = {}
mydata.colorTable.colorSelected = {{91,168,36},{15,87,138},{138,15,87},{15,138,66},{66,15,138},{168,113,36}}
								


local Pool = require("pool")

local _cellWidth = mydata.HorizontalDistance             --level.board.cellWidth
local _cellHeight = mydata.VerticalDistance                    --level.board.cellHeight
local distUnit = _cellWidth*_cellWidth+_cellHeight*_cellHeight

local HorizontalDistance = 2*mydata.HorizontalDistance 
local VerticalDistance = 2*mydata.VerticalDistance
local fullw = mydata.fullw
local fullh = mydata.fullh
local width = application:getContentWidth()
local height = application:getContentHeight()
local centerX = mydata.centerX
local centerY = height/2    --mydata.centerY
local dx = mydata.dx
local dy = mydata.dy
local _tall = mydata.tall


local Base = mydata.Base

------------------------------------------------------------GAMEBOARD-------------------------------------------

local _allSettled, _dirty = true, true
local _slots = {}
local _numCol, _numRow = 9,9
local math_random = math.random
local SLIDE_TIME = 100
local _baseSlots = {}

local _board = Sprite.new()
_board:setAnchorPoint(0,0)
_board:setPosition(0.5, 0)
stage:addChild(_board)
local _gameMode = nil

local pool = {}
for i=0,6 do
	if i~=8 or i~=13 or i~=11 then 
		pool[i] = Pool.create(i, 40, Base, _board, _gameMode, i, false, st)
	end
end
 


local function _newTopPiece(col, row)

        if _slots[_numRow*col+row]~=nil then return false end

        row = row or 0


        local i = math_random(1, 3)
        local piece = pool[i]:obtain()        
        _board:addChild(piece)



        local ycos

        if (not _tall) then

            piece:setX( centerX - 0.5*(_numCol-1)*_cellWidth + col*_cellWidth )      --_cellWidth * col  + (_cellWidth * 0.5)
            piece:setY( centerY - 0.5*(_numRow-1)*_cellHeight + row*_cellHeight- 0.25*_cellHeight )                 --_cellHeight * -1  + (_cellHeight * 0.5)
            if col%2==0 then
                piece:setY( piece:getY() + 0.5*_cellHeight )
            end
            
            piece.col, piece.row = col, 0        
            _slots[_numRow*col+0] = piece
            ycos = piece:getY()+0.25*_cellHeight

        elseif _tall then

            piece:setX( centerX - 0.5*(_numCol-1)*_cellWidth + col*_cellWidth )     --_cellWidth * col  + (_cellWidth * 0.5)
            piece:setY( centerY - 0.5*(_numRow-1)*_cellHeight + row*_cellHeight - _cellHeight )                  --_cellHeight * -1  + (_cellHeight * 0.5)
            if col%2==0 then
                piece:setY( piece:getY() + 0.5*_cellHeight )
            end
            
            piece.col, piece.row = col, row
                
            _slots[_numRow*col+row] = piece
            ycos = piece:getY() + _cellHeight

        end


        local function pieceF()

            if piece and piece.t then

                piece.t:setPaused(true)
                piece.t = nil
            end

            piece:ready() 
            _stale = true
            _dirty = true  
            piece.t = nil
                
            
        end

        piece.t = GTween.new(piece, 0.001*(SLIDE_TIME-65), {y = ycos}, {onComplete = pieceF})

        return true
end

function _board:getBasePiece(col, row)
    if col < 0 or col >= _numCol or row < 0 or row >=_numRow then
        return nil
    end
    return _baseSlots[_numRow*col+row]
end

function _board:canFallTo(piece, col, row, notEmpty, down)

    if (col < 0 or col >= _numCol or row < 0 or row >= _numRow)
    or (col == piece.prevCol and row == piece.prevRow) then
        return false
    end

    if piece.col == col then
        return _slots[_numRow*col+row] == nil
    end

    local top
    if not notEmpty then       
        top = _slots[_numRow*col+(row-1)]
    else top = _slots[_numRow*col+(row)]
    end

    local movable
    if top == nil then
        movable = false
    else
        movable = top.movable
    end

    return _slots[_numRow*col+row] == nil and not movable

end

function _board:slidePiece(piece, col, row, callback, dir)
        
        if col < 0 or col >= _numCol or row < 0 or row >= _numRow then
            return false
        end
        
        -- condition for vertical & horizontal movement
        if _slots[_numRow*col+row] ~= nil then            
            return false 
        end

        -- conditions for diagonal movement
        
        if piece.col ~= col then

            local test = false

            if piece.col%2~=0 then
                 
                --local test = false
                for y=row-1,0,-1 do
                    local p = _slots[_numRow*col+y]
                    if p ~= nil then
                        if (not p.movable) then
                            test =  true
                        end
                        break                    
                    end                
                end

            elseif piece.col%2==0 then 
                --local test = false
                for y=row-1,0,-1 do  -----row,0-1,-1 do
                    local p = _slots[_numRow*col+y]
                    if p ~= nil then
                        if not p.movable then
                            test =  true
                        end
                        break

                    end                
                end          
            end

            if not test then
                return false
            end

        end

        local settled = true

        if col%2~=0 then
            for y=row+1,_numRow-1 do  -----row,0-1,-1 do
                local p = _slots[_numRow*piece.col+y]
                if (p == nil) --or (p and not p.movable) 
                    then
                    settled = false
                end
            end

        elseif col%2==0 then
            for y=row+1,_numRow-2 do  -----row,0-1,-1 do
                local p = _slots[_numRow*piece.col+y]
                if (not p) --or (p and not p.movable) 
                    then
                    settled = false
                end
            end
        end

        if (not settled) then
                
            piece.prevCol, piece.prevRow = piece.col, piece.row
            _slots[_numRow*piece.col+piece.row] = nil        
            _slots[_numRow*col+row] = piece
            piece.col, piece.row = col, row
            _board:addChild(piece)


            local ycos = centerY-0.5*(_numRow-1)*_cellHeight+row*_cellHeight
            if col%2==0 then
                ycos = ycos+0.5*_cellHeight
            end

            local function pieceF()

                if piece and piece.t then

                    piece.t:setPaused(true)                    
                    piece.t =nil

                end

                piece.dirty = true
                _dirty = true
                callback(piece)
                piece.t = nil
  

            end

            piece.t = GTween.new(piece, 0.001*SLIDE_TIME, {x=centerX-0.5*(_numCol-1)*_cellWidth+col*_cellWidth, y=ycos}, {onComplete = pieceF})

        else
            piece.prevCol, piece.prevRow = piece.col, piece.row
            _slots[_numRow*piece.col+piece.row] = nil                    
            piece.col, piece.row = col, row
            _slots[_numRow*col+row] = piece
            _board:addChild(piece)
           

            local ycos = centerY-0.5*(_numRow-1)*_cellHeight+row*_cellHeight
            if col%2==0 then
                ycos = ycos+0.5*_cellHeight
            end

            local function pieceF()

                if piece and piece.t then

                    piece.t:setPaused(true)                    
                    piece.t = nil

                end
                    
                local y1 = piece:getY()

                local function pieceT1()

                    if piece and piece.t1 then

                        piece.t1:setPaused(true)
                        piece.t1 = nil

                    end

                    local function pieceT2()

                        piece.dirty = true
                        _dirty = true
                        callback(piece)
                        if piece and piece.t2 then

                            piece.t2:setPaused(true)
                            piece.t2 = nil

                        end

                    end

                    piece.t2 = GTween.new(piece, 0.001*SLIDE_TIME*0.2, { y=ycos}, {onComplete = pieceT2})

                end

                piece.t1 = GTween.new(piece, 0.001*SLIDE_TIME*0.8, {y=y1-0.2*_cellHeight}, {onComplete = pieceT1})--, ease = easing.outCircular})

            end

            piece.t = GTween.new(piece, 0.001*SLIDE_TIME*1.2, {x=centerX-0.5*(_numCol-1)*_cellWidth+col*_cellWidth, y=ycos}, {onComplete = pieceF})
            --piece:setPosition(centerX-0.5*(_numCol-1)*_cellWidth+col*_cellWidth, ycos)
            --piece.dirty = true
            --_dirty = true
        end


        return true

    end 

function _board:update(dt)

	if _dirty then

        local function newTop(col, row)

            local p = _slots[_numRow*col+row]
            local ball = _board:getBasePiece(col, row)

            if p == nil and (ball and (not ball.empty)) 
                then
                    --print("NEWTOP")

                local piece = _newTopPiece(col, row)
                
                if piece then
                    _dirty = true
                end

            elseif p == nil and (ball and ball.empty) then

                newTop(col, row+1)

            end
            
        end
    
        for col=0,_numCol-1 do

            newTop(col, 0)
        end

    end

    --------------------------------------------------------------------------------------------------------
    
    if _dirty then

        _allSettled = true

        for col=0,_numCol-1 do
            for row=0,_numRow-1 do                    
                local p = _slots[_numRow*col+row]
                if p ~= nil then                     
                    p:update()
                    _allSettled = _allSettled and p:isSettling() 
                end
            end
        end


        if _allSettled  then

        	--print("all settled")

        end

    end

end

-------------------------------------------------------------------------------------------------------------------------------------

local label1 = TextField.new(nil, "fps = ")
label1:setPosition(30, 100)
label1:setScale(2)

local label2 = TextField.new(nil, "textureMemory = ")
label2:setPosition(30, 200)
label2:setScale(2)

local label3 = TextField.new(nil, "LuaMemory = ")
label3:setPosition(30, 300)
label3:setScale(2)

stage:addChild(label1)	stage:addChild(label2)	stage:addChild(label3)


local frame = 0
local timer = os.timer()
local function displayFps()
	frame = frame + 1
	if frame == 60 then
		local currentTimer = os.timer()
		fps = 60 / (currentTimer - timer)
		label1:setText("fps = " .. math.floor(fps))
		label2:setText("textureMemory = " .. math.floor(application:getTextureMemoryUsage()))
		label3:setText("LuaMemory = " .. math.floor(collectgarbage("count")))
		frame = 0
		timer = currentTimer	
	end
end


local function enterFrameD(event)

	_dt = event.deltaTime      --curTime - _timeStamp
    _board:update(_dt) 
    displayFps()

end

stage:addEventListener(Event.ENTER_FRAME, enterFrameD, stage)









------------------------------------------------------------Setup-------------------------------------------------------------


local function _basePiece(kind, col, row)

    --mydata.colorFile has all the info about colors

    local piece = pool[0]:obtain()  --Piece.newPiece(_board, _gameMode, kind, false)
    piece:basePiece()
    _board:addChild(piece)
    piece:setScale(piece:getScaleX()*1.1, piece:getScaleY()*1.1)           --0.95        
    if _tall==true then
        piece:setScale(piece:getScaleX()*1.15, piece:getScaleY()*1.15)
    end

    piece.baseSprite:setColorTransform(98/255,98/255,98/255)
    --_board:addChild(piece)

    _baseSlots[_numRow*col+row] = piece
    --piece:setPosition(100, 200)

    piece:setX( centerX -(_numCol-1)/2*_cellWidth+col*_cellWidth )                           --_cellWidth * col  + (_cellWidth * 0.5)
    piece:setY( centerY - (_numRow-1)/2*_cellHeight +_cellHeight * row )
    piece.col = col
    piece.row = row
    if col%2==0 then
        piece:setY( piece:getY() + (_cellHeight * 0.5) )
        if row == _numRow-1 then
            _baseSlots[_numRow*col+row] = nil
            if piece then
                piece:removeFromParent()
                piece=nil
            end
            
        end 

    end

   
    return piece
end

for i=0,_numCol-1 do
    for j=0,_numRow-1 do

    	print("base")

    	_basePiece(Piece.FIXED, i, j)   

    end
end







--------------------------------------------------FB Instant Game---------------------------------------------

local FBInstant

pcall(function() mydata.FBInstant=require "FBInstant" end)
if mydata.FBInstant then

	local FBInstant = mydata.FBInstant

	mydata.platform = FBInstant.getPlatform()


	FBInstant.startGameAsync(function() 
		print("Loading screen removed")
		mydata.FBInstantAPI=true

	end)

end


